package ru.dbotthepony.mc.otm.block.decorative

import net.minecraft.core.BlockPos
import net.minecraft.world.item.ItemStack
import net.minecraft.world.level.block.EntityBlock
import net.minecraft.world.level.block.entity.BlockEntity
import net.minecraft.world.level.block.state.BlockState
import net.minecraft.world.level.storage.loot.LootParams
import net.minecraft.world.level.storage.loot.parameters.LootContextParams
import ru.dbotthepony.mc.otm.block.RotatableMatteryBlock
import ru.dbotthepony.mc.otm.block.entity.decorative.BreakableContainerBlockEntity

class BreakableContainerBlock(properties: Properties) : RotatableMatteryBlock(properties), EntityBlock {
	override fun newBlockEntity(pos: BlockPos, state: BlockState): BlockEntity {
		return BreakableContainerBlockEntity(pos, state)
	}

	override fun getDrops(state: BlockState, params: LootParams.Builder): MutableList<ItemStack> {
		val entity = params.getOptionalParameter(LootContextParams.BLOCK_ENTITY)

		if (entity is BreakableContainerBlockEntity)
			return entity.loot.getItems(params, state)

		return super.getDrops(state, params)
	}
}
