package ru.dbotthepony.mc.otm.data.codec

import com.mojang.serialization.Codec
import com.mojang.serialization.codecs.RecordCodecBuilder
import net.minecraft.core.component.DataComponentPatch
import net.minecraft.util.ExtraCodecs
import net.minecraft.world.item.ItemStack
import java.util.*
import kotlin.jvm.optionals.getOrElse

object EnhancedItemStackCodecs {
	val CODEC: Codec<ItemStack> by lazy {
		RecordCodecBuilder.create {
			it.group(
				ItemStack.ITEM_NON_AIR_CODEC.fieldOf("id").forGetter(ItemStack::getItemHolder),
				Codec.INT.minRange(1).fieldOf("count").orElse(1).forGetter(ItemStack::getCount),
				DataComponentPatch.CODEC.optionalFieldOf("components", DataComponentPatch.EMPTY).forGetter(ItemStack::getComponentsPatch)
			).apply(it, ::ItemStack)
		}
	}

	val OPTIONAL_CODEC: Codec<ItemStack> by lazy {
		ExtraCodecs.optionalEmptyMap(CODEC)
			.xmap({ it.getOrElse { ItemStack.EMPTY } }, { if (it.isEmpty) Optional.empty() else Optional.of(it) })
	}
}
